# WARNING - Generated by {fusen} from dev/flat_study_squirrels.Rmd: do not edit by hand

#' Read squirrels data in a folder
#'
#' @param folder_path Character. The path to the folder where to import data from
#'
#' @importFrom purrr possibly compact compact set_names
#' @importFrom readxl read_excel
#' @importFrom glue glue
#' @importFrom stringr str_extract
#' 
#' @return a list with all data imported from the folder
#' @export
#'
#' @examples
#'
#' tt <- read_data_day_squirrels(folder_path = system.file(package = "squirrels"))
#' str(tt, max.level = 1)
#'
#' # display the number of rows
#' tt |> purrr::map(.f = nrow) |> unlist()
#'
#'
read_data_day_squirrels <- function(folder_path){
  if(isFALSE(dir.exists(folder_path))) {
    stop(glue::glue("folder {folder_path} does not exist"))
  }
  
  files_to_import <- list.files(path = folder_path, 
                                pattern = "nyc_squirrels_[0-9][0-9].xlsx", 
                                full.names = TRUE)
  day_to_import <- stringr::str_extract(files_to_import,
                       pattern = "[0-9][0-9]")
  
  if(length(files_to_import) == 0){
    stop(glue::glue("no squirrel data found"))
  }
  
  possi_excel <- purrr::possibly(.f = readxl::read_excel,
                 otherwise = NULL)
  files_to_import |> 
    purrr::map(.f = possi_excel) |> 
    set_names(glue::glue("Squirrels_{day_to_import}")) -> output
  
  
  return(output)
  
}
